#include <stdio.h>
#include <stdlib.h>

#define MAXN 100000
#define MAXM 500000

int m, n;
int e[2*MAXM][2];
int ve[MAXN];
char was[MAXN];
int visited;

int mycmp(const void *ap, const void *bp)
{
  if (*(int *)ap == *(int *)bp)
    return ((int *)ap)[1]-((int *)bp)[1];
  return *(int *)ap - *(int *)bp;
}

void dfs(int a)
{
  int i;

  if (was[a])
    return;
  was[a] = 1;
  visited++;
  for (i = ve[a]; e[i][0] == a && i < 2*m; i++)
    dfs(e[i][1]);
}

int main(void)
{
  int i, tmp;

  scanf("%d %d", &n, &m);
  if (n < 1 || n > MAXN || m < 0 || m > MAXM) {
    printf("Spatna velikost vstupu!\n");
    return 1;
  }
  for (i = 0; i < m; i++) {
    if (scanf("%d %d", &e[2*i][0], &e[2*i][1]) != 2) {
      printf("Chyba pri nacitani hrany %d\n", i);
      return 1;
    }
    if (e[2*i][0] < 1 || e[2*i][0] > n || e[2*i][1] < 1 || e[2*i][1] > n || e[2*i][0] == e[2*i][1]) {
      printf("Spatna hrana %d\n", i);
      return 1;
    }
    e[2*i][0]--; e[2*i][1]--;
    e[2*i+1][1] = e[2*i][0];
    e[2*i+1][0] = e[2*i][1];
  }
  if (scanf("%d", &tmp) == 1) {
    printf("Hran je vice nez ma byt!\n");
    return 1;
  }

  qsort(e, 2*m, 2*sizeof(int), mycmp);
  ve[0] = 0;
  for (i = 1; i < 2*m; i++) {
    if (e[i][0] == e[i-1][0] && e[i][1] == e[i-1][1]) {
      printf("Hrana %d %d se opakuje.\n", e[i][0]+1, e[i][1]+1);
      return 1;
    }
    if (e[i][0] != e[i-1][0]) {
      if (e[i][0] != e[i-1][0]+1) {
        printf("Vrchol %d je izolovany!\n", e[i-1][0]+1);
        return 1;
      }
      else
        ve[e[i][0]] = i;
    }
  }
    
  dfs(0);
  if (visited != n) {
    printf("Graf neni souvisly.\n");
    return 1;
  }

  return 0;
}
